image: node:18.17.1-slim

stages:
  - version
  - package
  - publish
  - release

version:
  stage: version
  image: registry.gitlab.com/george.kimberley/go-semrel-gitlab:v0.26.0
  script:
    - release next-version > .next-version
    - release changelog -f CHANGELOG.md
  artifacts:
    paths:
    - .next-version
    - CHANGELOG.md
    expire_in: 1 week
  except:
    - tags

package:
  stage: package
  allow_failure: true
  script:
    - echo "BUILD_NAME=kick-assembler-vscode-ext-$(<.next-version)-$CI_COMMIT_SHORT_SHA.vsix" > build_info
    - echo "RELEASE_NAME=kick-assembler-vscode-ext-$(<.next-version).vsix" >> build_info
    - echo "RELEASE_SHA=$CI_COMMIT_SHA" >> build_info
    - echo "RELEASE_VERSION=$(<.next-version)" >> build_info
    - . build_info
    - echo $BUILD_NAME
    - echo $RELEASE_NAME
    - echo $RELEASE_SHA
    - echo $RELEASE_VERSION
    - cat CHANGELOG.md
    - npm ci --omit=dev
    - npx tsc -v
    - npm version $RELEASE_VERSION --allow-same-version
    - npx vsce@2.5.3 package -o $BUILD_NAME --baseContentUrl https://gitlab.com/retro-coder/commodore/kick-assembler-vscode-ext/blob/master --baseImagesUrl https://gitlab.com/retro-coder/commodore/kick-assembler-vscode-ext/raw/master
  artifacts:
    paths:
      - '*.log'
      - '*.vsix'
      - build_info
      - package.json
    expire_in: 1 month
  except:
    - tags

publish:
  stage: publish
  environment: 
    name: production
  variables:
  script:
    - . build_info
    - echo $BUILD_NAME
    - echo $RELEASE_NAME
    - echo "RELEASE_URL=https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/jobs/$CI_JOB_ID/artifacts/$RELEASE_NAME" >> build_info
    - cp $BUILD_NAME $RELEASE_NAME
    - npx vsce@2.5.3 publish -p $PAT --packagePath $RELEASE_NAME
    - npx ovsx@0.7.1 publish $RELEASE_NAME -p $PAT_OVSX 
  artifacts:
    paths:
      - '*.vsix'
      - build_info
    expire_in: 1 year
  when: manual
  allow_failure: false
  only:
    - master

release:
  stage: release
  environment: 
    name: production
  image: registry.gitlab.com/george.kimberley/go-semrel-gitlab:v0.26.0
  script:
    - . build_info
    - echo $RELEASE_NAME
    - echo $RELEASE_VERSION
    - echo $RELEASE_URL
    - release -v    
    - release commit-and-tag CHANGELOG.md package.json
    - release --ci-commit-tag v$RELEASE_VERSION add-download-link -n $RELEASE_NAME -u $RELEASE_URL -d "$RELEASE_NAME"
  only:
    - master
